# -*- coding: utf-8 -*-
"""
@author: Jose Manuel Martín Cabeza
"""

import StruPy2D as sp2

#----------------------------Codigo demostrativo apartado 4--------------------------------#

"""Materiales y secciones"""
materialA = sp2.Material('acero', 2.1e11 , 7850, 1.2e-5)
seccionA = sp2.Section('IPN100', A=10.6e-4, I=171e-8, h=0.1)

"""Nodos"""
nodo1 = sp2.Node(0,0)
nodo2 = sp2.Node(2.5,0)
nodo3 = sp2.Node(x=5,y=0,th=0)

"""Barras"""
barra1 = sp2.Bar('barra 1', nodo1, nodo2, materialA, seccionA)
barra2 = sp2.Bar('barra 2', nodo2, nodo3, materialA, seccionA)

"""Cargas"""
fuerza1 = sp2.Load('Fuerza 1', 'NOD', fx=10000, fy=10000)
nodo1.addLoad(fuerza1)  

"""Condiciones de contorno"""
nodo2.setBC(sp2.H_MOVING)
nodo3.setBC(sp2.CLAMPED)

"""Generar estructura"""
estructura= sp2.Structure([barra1,barra2])
estructura.setWeight('off')
estructura.show()

"""Calculo estatico"""
estatico = sp2.Static(estructura, run=True)
estatico.show(escaleDef=5)
for B in estatico.bars:
    print(B)
    
"""Calculo pandeo global"""
for i in range (3):
    pandeo = sp2.Buckling( estatico, run = True,verModo=i+1)
    pandeo.show()
print(pandeo)
