# -*- coding: utf-8 -*-
"""
@author: Jose Manuel Martín Cabeza
"""

import StruPy2D as sp2

#---------------------------Pescante caso 2-------------------------------#

"""Nodos"""
p1 = sp2.Node(0,0)
p11 = sp2.Node(0,0.5)
p12 = sp2.Node(0,1)
p13 = sp2.Node(0,1.5)
p14 = sp2.Node(0,2)
p15 = sp2.Node(0,2.5)
p16 = sp2.Node(0,3)
p17 = sp2.Node(0,3.5)

p2 = sp2.Node(0,4)
p21 = sp2.Node(0.5,4)
p22 = sp2.Node(1,4)
p23 = sp2.Node(1.5,4)
p24 = sp2.Node(2,4)
p25 = sp2.Node(2.5,4)
p26 = sp2.Node(3,4)
p27 = sp2.Node(3.5,4)

p3 = sp2.Node(4,4)

"""Materiales y secciones"""
m1 = sp2.Material('acero',2.1e11,7850)
s1 = sp2.Section('sec1',A=20e-3,I=220e-6,h=0.4)

"""Barras"""
b1 = sp2.Bar(1, p1, p11, m1, s1)
b2 = sp2.Bar(2, p11, p12, m1, s1)
b3 = sp2.Bar(3, p12, p13, m1, s1)
b4 = sp2.Bar(4, p13, p14, m1, s1)
b5 = sp2.Bar(5, p14, p15, m1, s1)
b6 = sp2.Bar(6, p15, p16, m1, s1)
b7 = sp2.Bar(7, p16, p17, m1, s1)
b8 = sp2.Bar(8, p17, p2, m1, s1)
b9 = sp2.Bar(9, p2, p21, m1, s1)
b10 = sp2.Bar(10, p21, p22, m1, s1)
b11 = sp2.Bar(11, p22, p23, m1, s1)
b12 = sp2.Bar(12, p23, p24, m1, s1)
b13 = sp2.Bar(13, p24, p25, m1, s1)
b14 = sp2.Bar(14, p25, p26, m1, s1)
b15 = sp2.Bar(15, p26, p27, m1, s1)
b16 = sp2.Bar(16, p27, p3, m1, s1)

"""Cargas"""
f1 = sp2.Load('f1','NOD',fx=-10000)
f2 = sp2.Load('f1','NOD',fy=-10000)
p2.addLoad(f1)
p2.addLoad(f2)

"""Condiciones de contorno"""
p1.setBC(sp2.CLAMPED)
p3.setBC(sp2.FIXED)

"""Generar estructura"""
S = sp2.Structure([b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12, b13, b14, b15, b16])
S.show()
S.setWeight('off')

"""Calculo estatico"""
St = sp2.Static(S, run=True)
for B in St.bars:
    print(B)

"""Calculo pandeo global"""    
for i in range(4):
    Bu = sp2.Buckling(St, run=True, verModo=i)
    Bu.show()
print(Bu)