# -*- coding: utf-8 -*-
"""
@author: Jose Manuel Martín Cabeza
"""

import StruPy2D as sp2

#---------------------------Viga continua caso 1-------------------------------#

"""Nodos"""
p1 = sp2.Node(0,0)
p2 = sp2.Node(5,0)
p3 = sp2.Node(15,0)

"""Materiales y secciones"""
m1 = sp2.Material('acero',2.1e11,7850)
s1 = sp2.Section('sec1',A=20e-3,I=220e-6,h=0.4)

"""Barras"""
b1 = sp2.Bar(1, p1, p2, m1, s1)
b2 = sp2.Bar(2, p2, p3, m1, s1)

"""Cargas"""
f1 = sp2.Load('f1','NOD',fx=-10000)
p3.addLoad(f1)

"""Condiciones de contorno"""
p1.setBC(sp2.CLAMPED)
p2.setBC(sp2.H_MOVING)
p3.setBC(sp2.H_MOVING)

"""Generar estructura"""
S = sp2.Structure([b1, b2])
S.show()
S.setWeight('off')

"""Calculo estatico"""
St = sp2.Static(S, run=True)
St.show()
for B in St.bars:
    print(B)

"""Calculo pandeo global"""    
Bu = sp2.Buckling(St, run=True, verModo=1)
Bu.show()
print(Bu)
